<?php
/******************************* CaptchaGuest ************************************/
/* Solution de securite pour limiter l'acces des robots spameurs */
/* Base sur une proposition de vin100 sur le forum PunBbFr */
/* voir : <http://www.punbb.fr/forums/viewtopic.php?pid=30840> */
/* Evolution grace a une contribution de BertrandB des forums PunBbFr */
/* Realisation : FredoMkb (c) 2007 */
/********************************************************************************/
/* Ce fichier contient toutes les fonctions d'analyse et de traitement du Captcha */
/* Placez ce fichier au meme niveau que le fichier Php nomme "post.php" */
/* de votre forum PunBb. */
/********************************************************************************/

/* Inclusion des valeurs et options */
include('CaptchaGuestValeurs.php');

// Pour choisir une liste de questions perticuliere, indiquez son numero
// dans la variable $theListNro.
// Les listes de questions disponibles par defaut sont :
// 0 (zero) = liste des calculs arithmetiques au format numerique (20 questions)
// 1 = liste des calculs arithmetiques au format textuel (20 questions)
// 2 = liste des questions avec des choix de reponse (10 questions)
// 3 = liste des questions de culture generale francaise (10 questions)
// Indiquez un nombre negatif pour choisir la liste de maniere aleatoire
$theListNro = -1; // -1 = choix aleatoire
session_start(); // On lance une session
if (isset($_SESSION['Captcha_List'])) { $theListNro = $_SESSION['Captcha_List']; }
list ($libelle, $inputSize, $inputMax, $captchaList) = getListItems($theListAll, $theListNro);

/* Fonctions de traitement */
// Fonction pour choisir la liste des questions a poser et pour recuperer ses infos.
function getListItems($theListAll, $theNro) {
	// session_start(); //On lance une session
	if ($theNro <= -1) { $theNro = rand(0, count($theListAll)-1); }
	$_SESSION['Captcha_List'] = $theNro;
	$theList = $theListAll[$theNro];
	$infos = $theList['infos'];
	$captchaList = array_slice ($theList, 1);
	return array ($infos['libelle'], $infos['inputSize'], $infos['inputMax'], $captchaList);
}

// Fonction pour convertir du texte Html en codes Ascii Html.
function asciihtml($textHtml) {
// Fonction pour retourner le texte Html fourni ($textHtml) converti en codes Ascii Html ($asciiHtml).
// Petite adaptation d'une contribution sur Spip'Contrib proposee par Jean Luc Girard et Coyote.
// Voir : <http://www.spip-contrib.net/Crypter-une-adresse-email>
// Utf<->Html, johan dot andersson at strateg dot se, 
// voir : <http://fr.php.net/manual/fr/function.utf8-decode.php#31815>
	$textHtml = html_entity_decode(htmlentities($textHtml, ENT_COMPAT, 'UTF-8'));
	$asciiHtml = '';
	for ($i = 0; $i < strlen($textHtml); $i++) {
		$asciiHtml .= '&#'.ord($textHtml[$i]).';';
	}
	return $asciiHtml;
}

// Fonction pour preparer la question du captcha
function captchaQuestion() {
	global $captchaList; // Utiliser les globales
	// session_start(); //On lance une session
	if (isset($_SESSION['Captcha_Index'])) {
		// Recuperation de la question
		$captchaIndex = $_SESSION['Captcha_Index'];
	} else {
		// Construction de la question
		$captchaIndex = rand(0, count($captchaList)-1); // Choix aleatoire d'un couple "question/reponse"
		//On stock dans la session la question
		$_SESSION['Captcha_Index'] = $captchaIndex;
	}
	$captchaQstsList = array_keys($captchaList); // Liste des questions
	$captchaQst = $captchaQstsList[$captchaIndex]; // La question choisie
	$captchaQstHtml = asciihtml($captchaQst.' ='); // Encodage ascii html de la question choisie
	// Retour des resultats
	return $captchaQstHtml;
}

// Fonction pour analyser la reponse au captcha
function captchaReponse() {
	global $captchaList, $conseilsList, $lang_common, $captchaConfig; // Utiliser les globales
	// session_start(); //On lance une session
	$limite = $captchaConfig['limite'];
	$conseil = $conseilsList[rand(0, count($conseilsList)-1)]; // Choix aleatoire d'un conseil
	// Recuperation des varialbes passees par $_POST
	$captchaRepUsr = strtolower(trim($_POST['captcha']));
	$messageOk = 0;
	$reponses = array_values($captchaList);
	// Si la reponse n'est pas correcte, on affiche un message d'information
	if ($reponses[$_SESSION['Captcha_Index']] != $captchaRepUsr) { $messageOk = 1; }
	// Compter le nombre de tentatives
	$finOk = 0;
	if (isset($_SESSION['Captcha_Nbr'])) {
		$_SESSION['Captcha_Nbr'] ++;  // Iteration du compteur
		if ($_SESSION['Captcha_Nbr'] >= $limite) { $finOk = 1; }
	} else {
		$_SESSION['Captcha_Nbr'] = 1; // Initialisation du compteur
	}
	// Construction des messages d'erreur
	$message = '<p><strong>R&eacute;ponse incorrecte, veuillez recommencer... </strong>';
	$message .= '<small style="color: gray;">(tentative '.$_SESSION['Captcha_Nbr'].'/'.$limite.')</small></p>';
	$message .= '<p>Conseil : <em>'.$conseil.'</em></p>';
	// Avertissement et lien lorsque la limite est depassee
	$avertoTxt = 'Vous avez &eacute;puis&eacute; le nombre de tentatives autoris&eacute;es !';
	$averto = '<p><strong style="color: maroon;">'.$avertoTxt.'</strong></p>';
	$averto .= '<p><a href="javascript:location.href=location">'.$lang_common['Go back'].'</a></p>';
	// Supperssion des infos de la session lorsque la limite est depassee
	if ($finOk) { 
		$message .= $averto; 
		eraseVars();
	}
	// Retour des resultats
	return array($messageOk, $message, $finOk);
}

// Fonction pour effacer les variables de session et de post
function eraseVars() {
	// session_start(); //On lance une session
	unset($_SESSION['Captcha_List']);
	unset($_SESSION['Captcha_Nbr']);
	unset($_SESSION['Captcha_Index']);
	unset($_POST['captcha']);
}

// Fonction pour sauvegarder les tentatives de post
function sauvLog() {
	global $captchaConfig; // Utiliser les globales
	// Si l'option de sauvegarde des tentatives de post est activee, on enregistre les infos.
	if ($captchaConfig['logOk']) {
		$captchaLogFile = $captchaConfig['logFile'];
		$captchaLogTxt = 'Date : '.date('Y/m/d-H:i:s').' - Url : '.get_remote_address()."\n";
		$captchaLogOpen = fopen($captchaLogFile, 'a');
		fwrite($captchaLogOpen, $captchaLogTxt);
		fclose($captchaLogOpen);
	}
}
/***************************** Fin CaptchaGuest **********************************/
?>