<?php
/*
##         Titre mod :  CaptchaGuest
##
##     Version mod :  1.1.0
##       Pour PunBB :  1.2.x
##               Date :  30/05/2007
##             Auteur :  FredoMkb (<http://fredomkb.free.fr/forum/>)
##
## Fichiers affectés :  post.php
##
##     Affecte la BD :  non
##
##    Description :  Cette mod permet d'afficher un petit captcha textuel
##                       de sécurité (<http://fr.wikipedia.org/wiki/Captcha>).
##                       afin d'autoriser aux visiteurs (guest) de participer
##                       aux forums tout en empêchant l'accès des robots de spam.
##                       
##                       Cette mod est une adaptation d'une contribution de 
##                       Vincent Garnier (vin100), sur les forums de PunBbFr 
##                       (<http://www.punbb.fr/forums/viewtopic.php?id=2621>).
##
##                       La version 1.1.0 est une evolution realisee grace a une 
##                       contribution de BertrandB, membre des forums de PunBbF.
##
##  Fonctionnalités :  Cette mod affiche, en bas de la page de rédaction  
##                       d'un nouveau message ou d'une nouvelle discussion,
##                       une question, tirée au hasard parmis 4 listes disponibles, 
##                       et demande à l'utilisateur de noter la bonne reponse 
##                       dans un champ dédié.
##
##                       Si la réponse est correcte lors de la validation, 
##                       le message sera accepté et publié, dans le cas contraire,  
##                       un avertissement s'affichera avec un lien "Retour", 
##                       invitant l'utilisateur à corriger le résultat proposé.
##                       Au bout de trois tentatives, le message de l'utilisateur
##                       est effacé et une nouvelle question captcha est affichée.
##
##  Personnalisations :  Vous pouvez modifier et personnaliser certaines 
##                       données utilisées, comme la liste des questions posées,
##                       le nombre de tentatives autorisées ainsi que la liste 
##                       des conseils prodigués aux utilisateurs étourdis...
##
##                       Ces éléments sont identifiables par un commentaire  
##                       contenant la mention "(a adapter selon vos besoins)",
##                       et ils sont desormais tous regroupes dans le fichier 
##                       Php nomme "CaptchaGuestValeurs.php".
##
##         Sécurité :  Le résultat de la question affichée, choisie au hasard,  
##                       qui permet de tester l'exactitude de la réponse fournie,  
##                       est desormais conservee dans une variable de session
##                       grace a la contribution de BertrandB des forums PunBbFr.
##
##                       De plus, les questions affichées sont converties en codes
##                       Ascii Html, correspondant au jeux de caractères à la norme
##                       ISO 8859-1 (<http://www.w3.org/TR/html4/sgml/entities.html>).
##                       Enfin, le nombre de tentatives de réponse est limitée.
##
##                       Cette version 1.1.0 ajoute la possibilite de conserver, 
##                       dans un fichier independant, des informations sur les tentatives
##                       de post, afin de pouvoir bannir d'eventuels robots de spam
##                       qui tenterait d'acceder au forum. 
##                       Pensez a effacer regulierement les donnees de ce fichier.
##
##                       ATTENTION !
##                       Comme cette mod est libre et accessible a tout le monde,
##                       si jamais vous activez la sauvegarde des tentatives de post
##                       (reglage par defaut), n'hesitez surtout pas à modifier 
##                       le nom par defaut du fichier recevant ces infos, afin d'empecher 
##                       d'autres personne a consulter ces informations a votre insu.
##
##  AVERTISSEMENTS :  Malgré les différents mécanismes de sécurité utilisés, 
##                       cette mod ne peut en aucun cas être considérée comme 
##                       une méthode réellement efficace et infaillible contre 
##                       les attaques de certains robots de spams sofistiqués.
##
##                       Si vous êtes victime d'attaques malgré cette protection,
##                       le plus sage est de désactiver l'option permettant aux 
##                       visiteurs de participer librement, tout en les invitant 
##                       à s'inscrire pour devenir membres de votre forum.
##
##                       ATTENTION !
##                       Cette protection n'a aucun effet avec l'option 
##                       de "Réponse rapide", veillez à la désactiver dans la zone
##                       d'administration de votre forum.
##
##    DISCLAIMER :  Veuillez noter que ces mods ne sont pas
##                       officiellement supportés par PunBB. L'installation
##                       de ces modifications est à vos risques et périls.
##                       N'oubliez pas de sauvegarder la base de données et
##                       les fichiers affectés avant de procéder à
##                       l'installation de cette modification.
*/


/*
#---------[ INSTALLATION ]------------------------------------------------------
#
#  Pour commencer, il faut placer les fichier Php nommes "CaptchaGuest.php"
#  et "CaptchaGuestValeurs.php" au meme niveau que le fichier "post.php" original 
#  de votre forum PunBb.
#
#  Ensuite, suivez les étapes ci-après pour réaliser l'intégration de cette mod.
#
#  Attention, les numéros de lignes de code fournis, sont juste à titre indicatif,
#  basés sur le fichier original de la version française de PunBb, numérotée 1.2.14 Fr-b, 
#  ils peuvent différer significativement si votre fichier a déjà été modifié, 
#  ou même lors de l'intégration de cette mod. 
#
#  ATTENTION !
#  Certains serveurs et/ou fournisseurs d'accès, imposent la présence 
#  d'un répertoire (dossier) nommé "sessions" (tout en miniuscules et au pluriel) 
#  à la racine de votre espace web. Si jamais vous êtes dans ce cas de figure, 
#  vous devrez créer ce répertoire (vide), s'il n'existe déjà, pour que cette mod 
#  puisse fonctionner correctement.
#
*/

/*
#---------[ 1. OUVRIR ]---------------------------------------------------------
*/

post.php


/*
#---------[ 2. TROUVER (lignes: 26-27) ]----------------------------------------
*/

define('PUN_ROOT', './');
require PUN_ROOT.'include/common.php';


/*
#---------[ 3. AJOUTER AVANT ]--------------------------------------------------
*/

/******************************* CaptchaGuest ************************************/
/* Solution de securite pour limiter l'acces des robots spameurs */
/* Base sur une proposition de vin100 sur le forum PunBbFr */
/* voir : <http://www.punbb.fr/forums/viewtopic.php?pid=30840> */
/* Evolution grace a une contribution de BertrandB des forums PunBbFr */
/* Realisation : FredoMkb (c) 2007 */
/********************************************************************************/
/* Inclusion de la Mod */
include('CaptchaGuest.php');
/***************************** Fin CaptchaGuest **********************************/


/*
#---------[ 4. TROUVER (lignes: 72-74) ]----------------------------------------
*/

// Did someone just hit "Submit" or "Preview"?
if (isset($_POST['form_sent']))
{


/*
#---------[ 5. AJOUTER APRES ]--------------------------------------------------
*/

/**************************** CaptchaGuest Reponse ********************************/
	if ($pun_user['is_guest'] && !isset($_POST['preview'])) {
		// Si option active, on sauvegarde les infos de tentative de post
		sauvLog();
		// On recupere la reponse, si elle n'est pas correcte, on affiche 
		// un message d'info, sinon on vide les variables de session
		$captchaRepRes = captchaReponse();
		if ($captchaRepRes[0]) { 
			message($captchaRepRes[1], $captchaRepRes[2]); 
		} else {
			eraseVars();
		}
	}
/************************** Fin CaptchaGuest Reponse ******************************/


/*
#---------[ 6. TROUVER (lignes: 519-532) ]--------------------------------------
*/

?>
			</div>
			<div class="inform">
				<fieldset>
					<legend><?php echo $lang_common['Options'] ?></legend>
					<div class="infldset">
						<div class="rbox">
							<?php echo implode('<br /></label>'."\n\t\t\t\t", $checkboxes).'<br /></label>'."\n" ?>
						</div>
					</div>
				</fieldset>
<?php

}


/*
#---------[ 7. AJOUTER APRES ]--------------------------------------------------
*/

/**************************** CaptchaGuest Question ********************************/
if ($pun_user['is_guest']) {
	global $libelle, $inputSize, $inputMax;
	$captchaQstRes = captchaQuestion();
?>
		<fieldset style="margin: 10px 0px 0px 0px;">
			<legend>S&eacute;curit&eacute;</legend>
			<div class="infldset">
				<p><?php echo $libelle ?></p>
				<p><strong><?php echo $captchaQstRes ?></strong>
					<input name="captcha" id="captcha" type="text" size="<?php echo $inputSize ?>" maxlength="<?php echo $inputMax ?>" value="<?php if (isset($_POST['captcha'])) { echo $_POST['captcha']; } ?>" style="text-align: center;" />
				</p>
			</div>
		</fieldset>
<?php
}
/************************** Fin CaptchaGuest Question ******************************/


/*
#---------[ 8. ENREGSITRER / ENVOYER SUR LE SERVEUR ]--------------------------
*/

?>